---
title: MediaRecorder.ondataavailable
slug: Web/API/MediaRecorder/ondataavailable
tags:
  - API
  - Audio
  - Media Capture
  - Media Recorder API
  - MediaRecorder
  - MediaStream Recording API
  - Property
  - Reference
  - Video
  - ondataavailable
---
<p>{{APIRef("MediaStream Recording")}}</p>

<p>The <strong><code>MediaRecorder.ondataavailable </code></strong>event handler (part of the <a href="/en-US/docs/Web/API/MediaStream_Recording_API">MediaStream Recording API</a>) handles the {{event("dataavailable")}} event, letting you run code in response to {{domxref("Blob")}} data being made available for use.</p>

<p>The <code>dataavailable</code> event is fired when the MediaRecorder delivers media data to your application for its use. The data is provided in a {{domxref("Blob")}} object that contains the data. This occurs in four situations:</p>

<ul>
 <li>When the media stream ends, any media data not already delivered to your <code>ondataavailable</code> handler is passed in a single {{domxref("Blob")}}.</li>
 <li>When {{domxref("MediaRecorder.stop()")}} is called, all media data which has been captured since recording began or the last time a <code>dataavailable</code> event occurred is delivered in a {{domxref("Blob")}}; after this, capturing ends.</li>
 <li>When {{domxref("MediaRecorder.requestData()")}} is called, all media data which has been captured since recording began or the last time a <code>dataavailable</code> event occurred is delivered; then a new <code>Blob</code> is created and media capture continues into that blob.</li>
 <li>If a <code>timeslice</code> property was passed into the {{domxref("MediaRecorder.start()")}} method that started media capture, a <code>dataavailable</code> event is fired every <code>timeslice</code> milliseconds. That means that each blob will have a specific time duration (except the last blob, which might be shorter, since it would be whatever is left over since the last event). So if the method call looked like this — <code>recorder.start(1000);</code> — the <code>dataavailable</code> event would fire after each second of media capture, and our event handler would be called every second with a blob of media data that's one second long. You can use <code>timeslice</code> alongside {{domxref("MediaRecorder.stop()")}} and {{domxref("MediaRecorder.requestData()")}} to produce multiple same-length blobs plus other shorter blobs as well.</li>
</ul>

<div class="note">
<p>The {{domxref("Blob")}} containing the media data is available in the {{event("dataavailable")}} event's <code>data</code> property.</p>
</div>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox"><span class="idlInterface" id="idl-def-IDBRequest"><span class="idlAttribute"><span class="idlInterface" id="idl-def-MediaRecorder"><span class="idlAttribute"><em>MediaRecorder</em>.ondataavailable = function(event) { ... }
<em>MediaRecorder</em>.addEventListener('dataavailable', function(event) { ... })</span></span></span></span>
</pre>

<h2 id="Example">Example</h2>

<pre class="brush: js" id="line1"><span>...
  var chunks = [];

  mediaRecorder.onstop = function(e) {
    console.log("data available after MediaRecorder.stop() called.");

    var audio = document.createElement('audio');
    audio.controls = true;
    var blob = new Blob(chunks, { 'type' : 'audio/ogg; codecs=opus' });
    var audioURL = window.URL.createObjectURL(blob);
    audio.src = audioURL;
    console.log("recorder stopped");
  }

  mediaRecorder.ondataavailable = function(e) {
    chunks.push(e.data);
  }

...</span>
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName("MediaStream Recording", "#dom-mediarecorder-ondataavailable", "MediaRecorder.ondataavailable")}}</td>
   <td>{{Spec2("MediaStream Recording")}}</td>
   <td>Initial definition</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.MediaRecorder.ondataavailable")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/API/MediaStream_Recording_API">Using the MediaStream Recording API</a></li>
 <li><a href="https://mdn.github.io/web-dictaphone/">Web Dictaphone</a>: MediaRecorder + getUserMedia + Web Audio API visualization demo, by <a href="https://twitter.com/chrisdavidmills">Chris Mills</a> (<a href="https://github.com/mdn/web-dictaphone/">source on Github</a>.)</li>
 <li><a href="http://simpl.info/mediarecorder/">simpl.info MediaStream Recording demo</a>, by <a href="https://twitter.com/sw12">Sam Dutton</a>.</li>
 <li>{{domxref("Navigator.getUserMedia")}}</li>
</ul>
